//-----------------------------------------------------------------

// Browsers Supported:

//  * Mozilla 1.0+ and browsers based on that and later versions (Netscape, Galeon)
//  * Internet Explorer 5.0+ with MSXML3.0+ installed (4.0 RTM and later preffered)

//-----------------------------------------------------------------
// What does it do:
// This script allows the following in Mozilla
//  Methods: transformNode(), transformNodeToObject()
//  Properties: xml (read), innerText(read/write), parseError (you should only read) 
//-----------------------------------------------------------------
// NOTES
// 1 Asynchronus loading
//  In IE, the async property specifies whether the script should wait for a
//  domObject.load("somefile.xml");
//  to finish loading before continuing execution of the next code line.
//  Mozilla does sem to have implemented such a property yet, but one 
//  can use the readyState property to see if the file is loaded (the property value will be 4)

//-----------------------------------------------------------------

// Sample use

/*

// Use the factory class to get the right object for the browser,
// then treat it as it's an IE DOMObject (meaning methods 'transFormNode',
// 'transFormNodeToObject' and the 'xml' property
var xmlDoc = MB_crossBrowserXMLFactory.createDOMDocument("","",null);
xmlDoc.load("pathTo/fileNameOf.xml");
var xslDoc = MB_crossBrowserXMLFactory.createDOMDocument("","",null);
xslDoc.load("pathTo/fileNameOf.xslt");
function transform()
{
		var oOut = MB_crossBrowserXMLFactory.createDOMDocument("","",null);
		xmlDoc.transformNodeToObject(xslDoc, oOut);
		document.getElementById("gridView").innerHTML = oOut.xml;
		document.getElementById("sourceView").value = oOut.xml;
}
*/

//-----------------------------------------------------------------
//browser detection
//-----------------------------------------------------------------
var isIE_XML  = (navigator.userAgent.toLowerCase().indexOf("msie") > -1)?true:false;
var isMoz_XML = (document.implementation && document.implementation.createDocument)?true:false;
//=================================================================
// IE Initialization
//=================================================================
//Possible prefixes ActiveX strings for DOM DOcument
var PROGID_LIST = ["Msxml2.DOMDocument.4.0", "Msxml2.DOMDocument.3.0", "MSXML2.DOMDocument", "MSXML.DOMDocument", "Microsoft.XmlDom"];
//When the proper prefix is found, store it here
var PROGID = "";
var nsCounter = 0;

// Mozilla Initialization
if(isMoz_XML)
{

	// Emulate IE's innerText (write)
	Element.prototype.__defineSetter__("innerText", function (sText)
	{
		var s = "" + sText;
		this.innerHTML = s.replace(/\&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
	});
	// Emulate IE's innerText (read)
	Element.prototype.__defineGetter__("innerText", function ()
	{
		function scrapTextNodes(oElem)
		{
			var s = "";
			for(i=0;i<oElem.childNodes.length;i++)
			{
				var oNode = oElem.childNodes[i];
				if(oNode.nodeType == 3)
					s += oNode.nodeValue;
				else if(oNode.nodeType == 1)
					s += "\n" + scrapTextNodes(oNode);
			}
			return s;
		};
		return scrapTextNodes(this);
	});	
	// Emulate the async property (doesn't really do anything...)
	Document.prototype.async = true;
	// Emulate the readystate property
	Document.prototype.readyState = "0";
	// Emulate the onreadystatechange event
	Document.prototype.onreadystatechange = null;
	// The parseError attribute
	Document.prototype.parseError = 0;
	// We save a reference to the original load() method
	Document.prototype.__load__ = Document.prototype.load;
	// Get a document object
	MB_crossBrowserXMLFactory.createDOMDocument  = function(strNamespaceURI, strRootTagName)
	{
		var oDOMDoc = null;
		//create the DOM Document the standards way
		oDOMDoc = document.implementation.createDocument(strNamespaceURI, strRootTagName, null);
		//add the event listener for the load event
		oDOMDoc.addEventListener("load", _Document_onload, false);
		//return the object
		return oDOMDoc;
	};
	// Emulate IE's loadXML() method
	Document.prototype.loadXML = function(strXML) 
	{
		//change the readystate
		changeReadyState(this, 1);
		// parse the string to a new doc
		var oDOMDoc = (new DOMParser()).parseFromString(strXML, "text/xml");
		// remove exising children from the document object
		while (this.hasChildNodes())
			this.removeChild(this.lastChild);
		// insert and import all new
		for (var i = 0; i < oDOMDoc.childNodes.length; i++)
			this.appendChild(this.importNode(oDOMDoc.childNodes[i], true));
		// immitate an onLoad event fire
		handleOnLoad(this);
	};
	//=============================================================
	// XSLT Section: transformNodeToObject, transformNode
	//=============================================================
	// Emulate IE's transformNodeToObject() method
	Document.prototype.transformNodeToObject = function(xslDoc, oResult)
	{
		var xsltProcessor = new XSLTProcessor();
		try
		{
			xsltProcessor.transformDocument(this, xslDoc, oResult, null);
		}
		catch(e)
		{
			throw(e);
		}
	};
	// Emulate IE's transformNode() method
	Document.prototype.transformNode = function(xslDoc)
	{
		var out = document.implementation.createDocument("", "", null);
		this.transformNodeToObject(xslDoc, out);
		var serializer = new XMLSerializer();
		try
		{
			var str = serializer.serializeToString(out);
		}
		catch(e)
		{
			throw(e);
		}
		return str;
	};	
	//=============================================================
	// XPath Section: selectNodes, selectSingleNode
	//=============================================================
	/*
	Document.prototype.setProperty = function(s1, s2){}
	
	// Emulate IE's selectNodes() method
	Document.prototype.selectNodes = function(sExp)
	{
		
	}
	
	// Emulate IE's selectSingleNode() method
	Document.prototype.selectSingleNode = function(sExp)
	{
		
	}
	*/
	// Emulate IE's xml property
	Document.prototype.__defineGetter__("xml", function ()
	{
		return (new XMLSerializer()).serializeToString(this);
	});

	// Extend the load() method
	Document.prototype.load = function(strURL)
	{
		//set the parseError to 0
		this.parseError = 0;
		//change the readyState
		changeReadyState(this, 1);
		//watch for errors
		try
		{
			//call the original load method
			this.__load__(strURL);
		}
		catch (objException)
		{
			//set the parseError attribute
			this.parseError = -9999999;
			//change the readystate
			changeReadyState(this, 4);
		}
	};
}
else if(isIE_XML)
{

	//define found flag
	var bFound = false;
	// pick up the most recent ActiveX ProgID
	for (var i=0; i < PROGID_LIST.length && !bFound; i++)
	{
		try 
		{
			var objXML = new ActiveXObject(PROGID_LIST[i]);
			//if we got here it works so save the ProgID
			PROGID = PROGID_LIST[i];
			bFound = true;
		}
		catch(objException){}
	}
	// Throw error if a proper ActiveX object is not available
	if(!bFound)
		throw "No DOM Document found on your computer. Please upgrade your browser.\n" +
		      "Browsers Supported: \n" +
		      " * Mozilla 1.0+ and browsers based on that (Netscape, Galeon)\n" +
		      " * Internet Explorer 5.0+ with MSXML3.0+ installed (4.0 recommended)";

	MB_crossBrowserXMLFactory.createDOMDocument  = function(strNamespaceURI, strRootTagName)
	{
		//variable for the created DOM Document
		var oDOMDoc = null;
		//create the DOM Document the IE way
		oDOMDoc = new ActiveXObject(PROGID);
		// async is false by default
		oDOMDoc.async = false;
		//if there is a root tag name, we need to preload the DOM
		if (strRootTagName)
		{
			//If there is both a namespace and root tag name, then
			//create an artifical namespace reference and load the XML.
			if (strNamespaceURI)
				oDOMDoc.loadXML("<a"+(++nsCounter)+":" + strRootTagName + " xmlns:a"+nsCounter+"=\"" + strNamespaceURI + "\" />");
			else
				oDOMDoc.loadXML("<" + strRootTagName + "/>");
		}
		//return the object
		return oDOMDoc;
	};
}

//-----------------------------------------------------------------
// Our factory; used to create a DOMDocument object through
// it's createDOMDocument() method
//-----------------------------------------------------------------
function MB_crossBrowserXMLFactory()
{
}


// Moz Utility functions
function handleOnLoad(oDOMDoc)
{
	//check for a parsing error
	if(!oDOMDoc.documentElement || oDOMDoc.documentElement.nodeName == "parsererror")
		oDOMDoc.parseError = -9999999;
	//change the readyState
	changeReadyState(oDOMDoc, 4);
}

function _Document_onload()
{
	//handle the onload event
	handleOnLoad(this);
}

function changeReadyState(oDOMDoc, iRS)
{
	//change the readyState
	oDOMDoc.readyState = iRS;
	//if there is an onreadystatechange event handler, run it
	if((oDOMDoc.onreadystatechange != null) && (typeof oDOMDoc.onreadystatechange == "function"))
		oDOMDoc.onreadystatechange();
}